Index: uspace/lib/net/include/ip_interface.h
===================================================================
--- uspace/lib/net/include/ip_interface.h	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/lib/net/include/ip_interface.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -34,27 +34,13 @@
 #define __NET_IP_INTERFACE_H__
 
+#include <net/socket_codes.h>
 #include <async.h>
 #include <ipc/services.h>
 
-#include <net_device.h>
-#include <packet/packet.h>
+#include <net/device.h>
+#include <net/packet.h>
 
-#include <in.h>
-#include <ip_codes.h>
-#include <socket_codes.h>
-
-#ifdef CONFIG_IL_TL_BUNDLE
-
-#include <ip_local.h>
-
-#define ip_received_error_msg  ip_received_error_msg_local
-#define ip_set_gateway_req     ip_set_gateway_req_local
-#define ip_packet_size_req     ip_packet_size_req_local
-#define ip_device_req          ip_device_req_local
-#define ip_add_route_req       ip_add_route_req_local
-#define ip_send_msg            ip_send_msg_local
-#define ip_get_route_req       ip_get_route_req_local
-
-#else
+#include <net/in.h>
+#include <net/ip_codes.h>
 
 #include <ip_remote.h>
@@ -67,6 +53,4 @@
 #define ip_send_msg            ip_send_msg_remote
 #define ip_get_route_req       ip_get_route_req_remote
-
-#endif
 
 /** @name IP module interface
@@ -90,15 +74,13 @@
  *  @param[in] me The requesting module service.
  *  @param[in] receiver The message receiver. Used for remote connection.
- *  @param[in] tl_received_msg The message processing function. Used if bundled together.
  *  @returns The phone of the needed service.
  *  @returns EOK on success.
  *  @returns Other error codes as defined for the bind_service() function.
  */
-extern int ip_bind_service(services_t service, int protocol, services_t me, async_client_conn_t receiver, tl_received_msg_t tl_received_msg);
+extern int ip_bind_service(services_t service, int protocol, services_t me, async_client_conn_t receiver);
 
 /** Connects to the IP module.
  *  @param service The IP module service. Ignored parameter.
  *  @returns The IP module phone on success.
- *  @returns 0 if called by the bundle module.
  */
 extern int ip_connect_module(services_t service);
Index: uspace/lib/net/include/ip_remote.h
===================================================================
--- uspace/lib/net/include/ip_remote.h	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/lib/net/include/ip_remote.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -34,11 +34,12 @@
 #define __NET_IP_REMOTE_H__
 
-#include <async.h>
 #include <ipc/services.h>
 
-#include <ip_codes.h>
-#include <inet.h>
-#include <in.h>
-#include <socket.h>
+#include <net/ip_codes.h>
+#include <net/inet.h>
+#include <net/in.h>
+#include <net/packet.h>
+#include <net/device.h>
+#include <net/socket.h>
 
 extern int ip_set_gateway_req_remote(int, device_id_t, in_addr_t);
Index: uspace/lib/net/include/net_checksum.h
===================================================================
--- uspace/lib/net/include/net_checksum.h	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/lib/net/include/net_checksum.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -27,84 +27,37 @@
  */
 
-/** @addtogroup net
- *  @{
+/** @addtogroup libnet
+ * @{
  */
 
 /** @file
- *  General CRC and checksum computation.
+ * General CRC and checksum computation.
  */
 
-#ifndef __NET_CHECKSUM_H__
-#define __NET_CHECKSUM_H__
+#ifndef LIBNET_CHECKSUM_H_
+#define LIBNET_CHECKSUM_H_
 
 #include <byteorder.h>
-
 #include <sys/types.h>
 
 /** IP checksum value for computed zero checksum.
- *  Zero is returned as 0xFFFF (not flipped)
+ * Zero is returned as 0xFFFF (not flipped)
  */
-#define IP_CHECKSUM_ZERO			0xFFFFu
+#define IP_CHECKSUM_ZERO	0xffffU
 
-/**	Computes CRC32 value.
- *  @param[in] seed Initial value. Often used as 0 or ~0.
- *  @param[in] data Pointer to the beginning of data to process.
- *  @param[in] length Length of the data in bits.
- *  @returns The computed CRC32 of the length bits of the data.
- */
 #ifdef ARCH_IS_BIG_ENDIAN
-	#define compute_crc32(seed, data, length)	compute_crc32_be(seed, (uint8_t *) data, length)
+#define compute_crc32(seed, data, length) \
+	compute_crc32_be(seed, (uint8_t *) data, length)
 #else
-	#define compute_crc32(seed, data, length)	compute_crc32_le(seed, (uint8_t *) data, length)
+#define compute_crc32(seed, data, length) \
+	compute_crc32_le(seed, (uint8_t *) data, length)
 #endif
 
-/**	Computes CRC32 value in the little-endian environment.
- *  @param[in] seed Initial value. Often used as 0 or ~0.
- *  @param[in] data Pointer to the beginning of data to process.
- *  @param[in] length Length of the data in bits.
- *  @returns The computed CRC32 of the length bits of the data.
- */
-extern uint32_t compute_crc32_le(uint32_t seed, uint8_t * data, size_t length);
-
-/**	Computes CRC32 value in the big-endian environment.
- *  @param[in] seed Initial value. Often used as 0 or ~0.
- *  @param[in] data Pointer to the beginning of data to process.
- *  @param[in] length Length of the data in bits.
- *  @returns The computed CRC32 of the length bits of the data.
- */
-extern uint32_t compute_crc32_be(uint32_t seed, uint8_t * data, size_t length);
-
-/** Computes sum of the 2 byte fields.
- *  Padds one zero (0) byte if odd.
- *  @param[in] seed Initial value. Often used as 0 or ~0.
- *  @param[in] data Pointer to the beginning of data to process.
- *  @param[in] length Length of the data in bytes.
- *  @returns The computed checksum of the length bytes of the data.
- */
-extern uint32_t compute_checksum(uint32_t seed, uint8_t * data, size_t length);
-
-/** Compacts the computed checksum to the 16 bit number adding the carries.
- *  @param[in] sum Computed checksum.
- *  @returns Compacted computed checksum to the 16 bits.
- */
-extern uint16_t compact_checksum(uint32_t sum);
-
-/** Returns or flips the checksum if zero.
- *  @param[in] checksum The computed checksum.
- *  @returns The internet protocol header checksum.
- *  @returns 0xFFFF if the computed checksum is zero.
- */
-extern uint16_t flip_checksum(uint16_t checksum);
-
-/** Computes the ip header checksum.
- *  To compute the checksum of a new packet, the checksum header field must be zero.
- *  To check the checksum of a received packet, the checksum may be left set.
- *  The zero (0) value will be returned in this case if valid.
- *  @param[in] data The header data.
- *  @param[in] length The header length in bytes.
- *  @returns The internet protocol header checksum.
- *  @returns 0xFFFF if the computed checksum is zero.
- */
-extern uint16_t ip_checksum(uint8_t * data, size_t length);
+extern uint32_t compute_crc32_le(uint32_t, uint8_t *, size_t);
+extern uint32_t compute_crc32_be(uint32_t, uint8_t *, size_t);
+extern uint32_t compute_checksum(uint32_t, uint8_t *, size_t);
+extern uint16_t compact_checksum(uint32_t);
+extern uint16_t flip_checksum(uint16_t);
+extern uint16_t ip_checksum(uint8_t *, size_t);
 
 #endif
Index: uspace/lib/net/include/net_interface.h
===================================================================
--- uspace/lib/net/include/net_interface.h	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/lib/net/include/net_interface.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -27,65 +27,26 @@
  */
 
-/** @addtogroup net
+/** @addtogroup libnet
  *  @{
  */
 
-#ifndef __NET_NET_INTERFACE_H__
-#define __NET_NET_INTERFACE_H__
+#ifndef LIBNET_NET_INTERFACE_H_
+#define LIBNET_NET_INTERFACE_H_
 
 #include <ipc/services.h>
 
-#include <net_device.h>
+#include <net/device.h>
 #include <adt/measured_strings.h>
 
 /** @name Networking module interface
- *  This interface is used by other modules.
+ * This interface is used by other modules.
  */
 /*@{*/
 
-/** Returns the device specific configuration.
- *  Returns the global configuration if the device specific is not found.
- *  The configuration names are read and the appropriate settings are set instead.
- *  Call net_free_settings() function to release the returned configuration.
- *  @param[in] net_phone The networking module phone.
- *  @param[in] device_id The device identifier.
- *  @param[in,out] configuration The requested device configuration. The names are read and the appropriate settings are set instead.
- *  @param[in] count The configuration entries count.
- *  @param[in,out] data The configuration and settings data.
- *  @returns EOK on success.
- *  @returns EINVAL if the configuration is NULL.
- *  @returns EINVAL if the count is zero (0).
- *  @returns Other error codes as defined for the generic_translate_req() function.
- */
-extern int net_get_device_conf_req(int net_phone, device_id_t device_id, measured_string_ref * configuration, size_t count, char ** data);
-
-/** Returns the global configuration.
- *  The configuration names are read and the appropriate settings are set instead.
- *  Call net_free_settings() function to release the returned configuration.
- *  @param[in] net_phone The networking module phone.
- *  @param[in,out] configuration The requested configuration. The names are read and the appropriate settings are set instead.
- *  @param[in] count The configuration entries count.
- *  @param[in,out] data The configuration and settings data.
- *  @returns EOK on success.
- *  @returns EINVAL if the configuration is NULL.
- *  @returns EINVAL if the count is zero (0).
- *  @returns Other error codes as defined for the generic_translate_req() function.
- */
-extern int net_get_conf_req(int net_phone, measured_string_ref * configuration, size_t count, char ** data);
-
-/** Frees the received settings.
- *  @param[in] settings The received settings.
- *  @param[in] data The received settings data.
- *  @see net_get_device_conf_req()
- *  @see net_get_conf_req()
- */
-extern void net_free_settings(measured_string_ref settings, char * data);
-
-/** Connects to the networking module.
- *  @param service The networking module service. Ignored parameter.
- *  @returns The networking module phone on success.
- *  @returns 0 if called by the bundle module.
- */
-extern int net_connect_module(services_t service);
+extern int net_get_device_conf_req(int, device_id_t, measured_string_ref *,
+    size_t, char **);
+extern int net_get_conf_req(int, measured_string_ref *, size_t, char **);
+extern void net_free_settings(measured_string_ref, char *);
+extern int net_connect_module(void);
 
 /*@}*/
Index: uspace/lib/net/include/netif_interface.h
===================================================================
--- uspace/lib/net/include/netif_interface.h	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/lib/net/include/netif_interface.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -34,24 +34,6 @@
 #define __NET_NETIF_INTERFACE_H__
 
-#ifdef CONFIG_NETIF_NIL_BUNDLE
-
-#include <netif_local.h>
-#include <netif_nil_bundle.h>
-#include <packet/packet_server.h>
-
-#define netif_module_message    netif_nil_module_message
-#define netif_module_start      netif_nil_module_start
-#define netif_get_addr_req      netif_get_addr_req_local
-#define netif_probe_req         netif_probe_req_local
-#define netif_send_msg          netif_send_msg_local
-#define netif_start_req         netif_start_req_local
-#define netif_stop_req          netif_stop_req_local
-#define netif_stats_req         netif_stats_req_local
-#define netif_bind_service      netif_bind_service_local
-
-#else /* CONFIG_NETIF_NIL_BUNDLE */
-
 #include <netif_remote.h>
-#include <packet/packet_client.h>
+#include <packet_client.h>
 
 #define netif_module_message    netif_module_message_standalone
@@ -65,6 +47,4 @@
 #define netif_bind_service      netif_bind_service_remote
 
-#endif /* CONFIG_NETIF_NIL_BUNDLE */
-
 #endif
 
Index: uspace/lib/net/include/netif_local.h
===================================================================
--- uspace/lib/net/include/netif_local.h	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/lib/net/include/netif_local.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -34,5 +34,4 @@
  * Network interface module skeleton.
  * The skeleton has to be part of each network interface module.
- * The skeleton can be also part of the module bundled with the network interface layer.
  */
 
@@ -44,9 +43,9 @@
 #include <ipc/ipc.h>
 #include <ipc/services.h>
+#include <err.h>
 
 #include <adt/measured_strings.h>
-#include <net_err.h>
-#include <net_device.h>
-#include <packet/packet.h>
+#include <net/device.h>
+#include <net/packet.h>
 
 /** Network interface device specific data.
Index: uspace/lib/net/include/netif_remote.h
===================================================================
--- uspace/lib/net/include/netif_remote.h	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/lib/net/include/netif_remote.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -34,7 +34,7 @@
 #define __NET_NETIF_REMOTE_H__
 
-#include <async.h>
-#include <fibril_synch.h>
-#include <ipc/ipc.h>
+#include <ipc/services.h>
+#include <adt/measured_strings.h>
+#include <net/device.h>
 
 extern int netif_get_addr_req_remote(int, device_id_t, measured_string_ref *,
Index: uspace/lib/net/include/nil_interface.h
===================================================================
--- uspace/lib/net/include/nil_interface.h	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/lib/net/include/nil_interface.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -38,10 +38,8 @@
 
 #include <ipc/ipc.h>
+#include <ipc/nil.h>
 
-#include <net_messages.h>
-#include <adt/measured_strings.h>
-#include <packet/packet.h>
-#include <nil_messages.h>
-#include <net_device.h>
+#include <generic.h>
+#include <nil_remote.h>
 
 #define nil_bind_service(service, device_id, me, receiver) \
@@ -67,22 +65,6 @@
 	    netif_service)
 
-
-#ifdef CONFIG_NETIF_NIL_BUNDLE
-
-#include <nil_local.h>
-#include <packet/packet_server.h>
-
-#define nil_device_state_msg  nil_device_state_msg_local
-#define nil_received_msg      nil_received_msg_local
-
-#else /* CONFIG_NETIF_NIL_BUNDLE */
-
-#include <nil_remote.h>
-#include <packet/packet_server.h>
-
 #define nil_device_state_msg  nil_device_state_msg_remote
 #define nil_received_msg      nil_received_msg_remote
-
-#endif /* CONFIG_NETIF_NIL_BUNDLE */
 
 #endif
Index: uspace/lib/net/include/nil_remote.h
===================================================================
--- uspace/lib/net/include/nil_remote.h	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/lib/net/include/nil_remote.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -34,7 +34,7 @@
 #define __NET_NIL_REMOTE_H__
 
-#include <async.h>
-#include <fibril_synch.h>
-#include <ipc/ipc.h>
+#include <ipc/services.h>
+#include <net/device.h>
+#include <net/packet.h>
 
 extern int nil_device_state_msg_remote(int, device_id_t, int);
Index: uspace/lib/net/include/packet_client.h
===================================================================
--- uspace/lib/net/include/packet_client.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
+++ uspace/lib/net/include/packet_client.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -0,0 +1,117 @@
+/*
+ * Copyright (c) 2009 Lukas Mejdrech
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libnet
+ *  @{
+ */
+
+/** @file
+ * Packet client.
+ *
+ * To function correctly, initialization of the packet map by the pm_init()
+ * function has to happen at the first place. The module should not send the
+ * packet messages to the packet server but use the functions provided. The
+ * packet map should be released by the pm_destroy() function during the module
+ * termination. The packets and the packet queues can't be locked at all. The
+ * processing modules should process them sequentially - by passing the packets
+ * to the next module and stopping using the passed ones.
+ *
+ * @see packet.h
+ */
+
+#ifndef LIBNET_PACKET_CLIENT_H_
+#define LIBNET_PACKET_CLIENT_H_
+
+#include <net/packet.h>
+
+/** @name Packet client interface */
+/*@{*/
+
+/** Allocates the specified type right before the actual packet content and
+ * returns its pointer.
+ *
+ * The wrapper of the packet_prepend() function.
+ *
+ * @param[in] packet	The packet to be used.
+ * @param[in] type	The type to be allocated at the beginning of the packet
+ *			content.
+ * @returns		The typed pointer to the allocated memory.
+ * @returns		NULL if the packet is not valid.
+ * @returns		NULL if there is not enough memory left.
+ */
+#define PACKET_PREFIX(packet, type) \
+	(type *) packet_prefix((packet), sizeof(type))
+
+/** Allocates the specified type right after the actual packet content and
+ * returns its pointer.
+ *
+ * The wrapper of the packet_append() function.
+ *
+ * @param[in] packet	The packet to be used.
+ * @param[in] type	The type to be allocated at the end of the packet
+ *			content.
+ * @returns		The typed pointer to the allocated memory.
+ * @returns		NULL if the packet is not valid.
+ * @returns		NULL if there is not enough memory left.
+ */
+#define PACKET_SUFFIX(packet, type) \
+	(type *) packet_suffix((packet), sizeof(type))
+
+/** Trims the actual packet content by the specified prefix and suffix types.
+ *
+ * The wrapper of the packet_trim() function.
+ *
+ * @param[in] packet	The packet to be trimmed.
+ * @param[in] prefix	The type of the prefix to be removed from the beginning
+ *			of the packet content.
+ * @param[in] suffix	The type of the suffix to be removed from the end of
+ *			the packet content.
+ * @returns		EOK on success.
+ * @returns		EINVAL if the packet is not valid.
+ * @returns		ENOMEM if there is not enough memory left.
+ */
+#define PACKET_TRIM(packet, prefix, suffix) \
+	packet_trim((packet), sizeof(prefix), sizeof(suffix))
+
+extern void *packet_prefix(packet_t, size_t);
+extern void *packet_suffix(packet_t, size_t);
+extern int packet_trim(packet_t, size_t, size_t);
+extern int packet_copy_data(packet_t, const void *, size_t);
+extern packet_id_t packet_get_id(const packet_t);
+extern size_t packet_get_data_length(const packet_t);
+extern void *packet_get_data(const packet_t);
+extern int packet_get_addr(const packet_t, uint8_t **, uint8_t **);
+extern int packet_set_addr(packet_t, const uint8_t *, const uint8_t *, size_t);
+extern packet_t packet_get_copy(int phone, packet_t packet);
+
+/*@}*/
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/net/include/packet_remote.h
===================================================================
--- uspace/lib/net/include/packet_remote.h	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/lib/net/include/packet_remote.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -27,12 +27,13 @@
  */
 
-/** @addtogroup packet
+/** @addtogroup libnet
  * @{
  */
 
-#ifndef __NET_PACKET_REMOTE_H__
-#define __NET_PACKET_REMOTE_H__
+#ifndef LIBNET_PACKET_REMOTE_H_
+#define LIBNET_PACKET_REMOTE_H_
 
-#include <packet/packet.h>
+#include <net/packet.h>
+#include <sys/types.h>
 
 extern int packet_translate_remote(int, packet_ref, packet_id_t);
Index: uspace/lib/net/include/socket_core.h
===================================================================
--- uspace/lib/net/include/socket_core.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
+++ uspace/lib/net/include/socket_core.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -0,0 +1,139 @@
+/*
+ * Copyright (c) 2009 Lukas Mejdrech
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libnet 
+ *  @{
+ */
+
+/** @file
+ * Socket common core.
+ */
+
+#ifndef LIBNET_SOCKET_CORE_H_
+#define LIBNET_SOCKET_CORE_H_
+
+#include <sys/types.h>
+#include <adt/generic_char_map.h>
+#include <adt/dynamic_fifo.h>
+#include <adt/int_map.h>
+#include <net/in.h>
+#include <net/device.h>
+#include <net/packet.h>
+
+/** Initial size of the received packet queue. */
+#define SOCKET_INITIAL_RECEIVED_SIZE	4
+
+/** Maximum size of the received packet queue. */
+#define SOCKET_MAX_RECEIVED_SIZE	0
+
+/** Initial size of the sockets for acceptance queue. */
+#define SOCKET_INITIAL_ACCEPTED_SIZE	1
+
+/** Maximum size of the sockets for acceptance queue. */
+#define SOCKET_MAX_ACCEPTEDED_SIZE	0
+
+/** Listening sockets' port map key. */
+#define SOCKET_MAP_KEY_LISTENING	"L"
+
+/** Type definition of the socket core.
+ * @see socket_core
+ */
+typedef struct socket_core socket_core_t;
+
+/** Type definition of the socket core pointer.
+ * @see socket_core
+ */
+typedef socket_core_t *socket_core_ref;
+
+/** Type definition of the socket port.
+ * @see socket_port
+ */
+typedef struct socket_port socket_port_t;
+
+/** Type definition of the socket port pointer.
+ * @see socket_port
+ */
+typedef socket_port_t *socket_port_ref;
+
+/** Socket core. */
+struct socket_core {
+	/** Socket identifier. */
+	int socket_id;
+	/** Client application phone. */
+	int phone;
+	/** Bound port. */
+	int port;
+	/** Received packets queue. */
+	dyn_fifo_t received;
+	/** Sockets for acceptance queue. */
+	dyn_fifo_t accepted;
+	/** Protocol specific data. */
+	void *specific_data;
+	/** Socket ports map key. */
+	const char *key;
+	/** Length of the Socket ports map key. */
+	size_t key_length;
+};
+
+/** Sockets map.
+ * The key is the socket identifier.
+ */
+INT_MAP_DECLARE(socket_cores, socket_core_t);
+
+/** Bount port sockets map.
+ *
+ * The listening socket has the SOCKET_MAP_KEY_LISTENING key identifier whereas
+ * the other use the remote addresses.
+ */
+GENERIC_CHAR_MAP_DECLARE(socket_port_map, socket_core_ref);
+
+/** Ports map.
+ * The key is the port number.
+ */
+INT_MAP_DECLARE(socket_ports, socket_port_t);
+
+extern void socket_cores_release(int, socket_cores_ref, socket_ports_ref,
+    void (*)(socket_core_ref));
+extern int socket_bind(socket_cores_ref, socket_ports_ref, int, void *, size_t,
+    int, int, int);
+extern int socket_bind_free_port(socket_ports_ref, socket_core_ref, int, int,
+    int);
+extern int socket_create(socket_cores_ref, int, void *, int *);
+extern int socket_destroy(int, int, socket_cores_ref, socket_ports_ref,
+    void (*)(socket_core_ref));
+extern int socket_reply_packets(packet_t, size_t *);
+extern socket_core_ref socket_port_find(socket_ports_ref, int, const char *,
+    size_t);
+extern void socket_port_release(socket_ports_ref, socket_core_ref);
+extern int socket_port_add(socket_ports_ref, int, socket_core_ref,
+    const char *, size_t);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/net/include/tl_common.h
===================================================================
--- uspace/lib/net/include/tl_common.h	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/lib/net/include/tl_common.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -38,8 +38,8 @@
 #define __NET_TL_COMMON_H__
 
-#include <packet/packet.h>
-#include <net_device.h>
-#include <inet.h>
-#include <socket_codes.h>
+#include <net/socket_codes.h>
+#include <net/packet.h>
+#include <net/device.h>
+#include <net/inet.h>
 
 /** Device packet dimensions.
Index: uspace/lib/net/include/tl_interface.h
===================================================================
--- uspace/lib/net/include/tl_interface.h	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/lib/net/include/tl_interface.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -40,10 +40,10 @@
 #include <async.h>
 #include <ipc/services.h>
+#include <ipc/tl.h>
 
-#include <net_messages.h>
-#include <net_device.h>
-#include <packet/packet.h>
-#include <packet/packet_client.h>
-#include <tl_messages.h>
+#include <generic.h>
+#include <net/device.h>
+#include <net/packet.h>
+#include <packet_client.h>
 
 /** @name Transport layer module interface
Index: uspace/lib/net/netif/netif_local.c
===================================================================
--- uspace/lib/net/netif/netif_local.c	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/lib/net/netif/netif_local.c	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -42,17 +42,16 @@
 #include <ipc/ipc.h>
 #include <ipc/services.h>
-
-#include <net_err.h>
-#include <net_messages.h>
-#include <net_modules.h>
-#include <packet/packet.h>
-#include <packet/packet_client.h>
-#include <packet/packet_server.h>
+#include <ipc/netif.h>
+#include <err.h>
+
+#include <generic.h>
+#include <net/modules.h>
+#include <net/packet.h>
+#include <packet_client.h>
 #include <packet_remote.h>
 #include <adt/measured_strings.h>
-#include <net_device.h>
+#include <net/device.h>
 #include <nil_interface.h>
 #include <netif_local.h>
-#include <netif_messages.h>
 #include <netif_interface.h>
 
@@ -228,22 +227,4 @@
 	
 	return ERROR_CODE;
-}
-
-/** Create bidirectional connection with the network interface module and registers the message receiver.
- *
- * @param[in] service   The network interface module service.
- * @param[in] device_id The device identifier.
- * @param[in] me        The requesting module service.
- * @param[in] receiver  The message receiver.
- *
- * @return The phone of the needed service.
- * @return EOK on success.
- * @return Other error codes as defined for the bind_service() function.
- *
- */
-int netif_bind_service_local(services_t service, device_id_t device_id,
-    services_t me, async_client_conn_t receiver)
-{
-	return EOK;
 }
 
Index: uspace/lib/net/netif/netif_remote.c
===================================================================
--- uspace/lib/net/netif/netif_remote.c	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/lib/net/netif/netif_remote.c	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -36,12 +36,13 @@
 
 #include <ipc/services.h>
+#include <ipc/netif.h>
 
-#include <net_modules.h>
+#include <net/modules.h>
 #include <adt/measured_strings.h>
-#include <packet/packet.h>
-#include <packet/packet_client.h>
-#include <net_device.h>
+#include <net/packet.h>
+#include <packet_client.h>
+#include <net/device.h>
 #include <netif_remote.h>
-#include <netif_messages.h>
+#include <generic.h>
 
 int netif_get_addr_req_remote(int netif_phone, device_id_t device_id,
@@ -90,4 +91,17 @@
 }
 
+/** Create bidirectional connection with the network interface module and
+ * registers the message receiver.
+ *
+ * @param[in] service   The network interface module service.
+ * @param[in] device_id The device identifier.
+ * @param[in] me        The requesting module service.
+ * @param[in] receiver  The message receiver.
+ *
+ * @return The phone of the needed service.
+ * @return EOK on success.
+ * @return Other error codes as defined for the bind_service() function.
+ *
+ */
 int netif_bind_service_remote(services_t service, device_id_t device_id, services_t me,
     async_client_conn_t receiver)
Index: uspace/lib/net/nil/nil_remote.c
===================================================================
--- uspace/lib/net/nil/nil_remote.c	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/lib/net/nil/nil_remote.c	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -36,11 +36,12 @@
  */
 
-#include <net_messages.h>
-#include <net_device.h>
+#include <nil_remote.h>
 #include <nil_interface.h>
-#include <packet/packet.h>
-#include <packet/packet_client.h>
-#include <nil_messages.h>
-#include <nil_remote.h>
+#include <generic.h>
+#include <net/device.h>
+#include <net/packet.h>
+#include <packet_client.h>
+
+#include <ipc/nil.h>
 
 /** Notify the network interface layer about the device state change.
Index: uspace/lib/net/tl/icmp_client.c
===================================================================
--- uspace/lib/net/tl/icmp_client.c	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/lib/net/tl/icmp_client.c	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -43,8 +43,8 @@
 #include <sys/types.h>
 
-#include <icmp_codes.h>
+#include <net/icmp_codes.h>
 #include <icmp_client.h>
-#include <packet/packet.h>
-#include <packet/packet_client.h>
+#include <net/packet.h>
+#include <packet_client.h>
 #include <icmp_header.h>
 
Index: uspace/lib/net/tl/icmp_remote.c
===================================================================
--- uspace/lib/net/tl/icmp_remote.c	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/lib/net/tl/icmp_remote.c	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -40,11 +40,10 @@
 #include <ipc/ipc.h>
 #include <ipc/services.h>
+#include <ipc/icmp.h>
 #include <sys/types.h>
 
-#include <net_messages.h>
-#include <net_modules.h>
+#include <net/modules.h>
 #include <icmp_interface.h>
-#include <packet/packet_client.h>
-#include <icmp_messages.h>
+#include <packet_client.h>
 
 int icmp_destination_unreachable_msg(int icmp_phone, icmp_code_t code, icmp_param_t mtu, packet_t packet){
